package tracer;

public class BilinearSampler extends NearestSampler
{
	public BilinearSampler(String filename)
	{
		super(filename);
	}
	
	
	public Vec3 sample(float u, float v)
	{
		/*
		 * Bilinear Sampler,
		 * Dit werkt door de dichtsbijzijnde buren. dat wordt dus
		 * u afgerond, u afgrond+1, v afgerond, v afgerond+1
		 * omdat als je dichter bij een punt zit, deze kleur sterker moet meetellen,
		 * zit je met de uprime en vprime, wat dus waarde tussen 0 en 1 zijn.
		 * 
		 */
		u = scaleU(u);
		v = scaleV(v);
		
		float i = (float) Math.floor(u);
		float j = (float) Math.floor(v);
		
		float uprime = u - i;
		float vprime = v - j;
			
		return rawReadVec(i, j).times((1-uprime)*(1-vprime)).add(
				rawReadVec(i+1, j).times((1-vprime)*uprime).add(
				rawReadVec(i, j+1).times(vprime*(1-uprime)).add(
				rawReadVec(i+1, j+1).times(uprime*vprime))));
		
		
	}
}
